/* przyklad sortowania przez scalanie */
/* Uwaga, uywamy wtkw! przy kompilacji trzeba doda do gcc -lpthread */
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <sys/times.h>

typedef struct {
	int lewy;
	int srodkowy;
	int prawy;
} Arg; 


/* ile elementw ma mie tablica */
#define N 40000
int tab[N];
int tab_wy[N];

/* sortowanie przez zamiane prosta, argumenty lewy i prawy */
/* oznaczaja zakresy na jakich ma dzialac sortowanie       */
void *sort(void *argumenty)
{
int ii,jj;
int pom;
Arg *arg = (Arg*)argumenty;
printf("Bdziemy liczy L=%d P=%d\n",arg->lewy,arg->prawy);
for (ii=arg->lewy;ii<arg->prawy;ii++)
{
for (jj=ii+1; jj<=arg->prawy; jj++)
    {
    if (tab[jj]<tab[ii])
	{
	pom=tab[jj];
	tab[jj]=tab[ii];
	tab[ii]=pom;
	}
    }
}
printf("wtek %ld skonczyl\n",pthread_self());
return NULL;
}

/* funkcja scalajca dwa podciagi argumentami ograniczenia  */
/* w globalnej tablicy tab				    */
void scal(Arg *arg)
{
int licz1,licz2,licz_wy=0;
int ind1,ind2;
licz1=arg->lewy;
licz2=arg->srodkowy;
while (licz1 < arg->srodkowy)
    {
    if (tab[licz1] < tab[licz2])
	{
	tab_wy[licz_wy++] = tab[licz1++];
	if (licz1>=arg->srodkowy)
	//lewa czesc juz sie skonczyla przepisz reszte
	for (ind2=licz2;ind2<=arg->prawy;ind2++)
	    {
	    tab_wy[licz_wy++] = tab[ind2];
	    }
	}
    else
	{
	tab_wy[licz_wy++] = tab[licz2++];
	if (licz2>arg->prawy)
	    {
	    for (ind1=licz1; ind1<arg->srodkowy;ind1++)
		{
		tab_wy[licz_wy++] = tab[ind1];
		}
	    licz1=arg->srodkowy; //zakoncz
	    }
	}
    }
}

/* funkcja do pokazywania tabliczk, testowo */
void pokaz(int *t)
{
int ii;
for (ii = 0;ii<N;ii++)
	printf("%d ",t[ii]);
printf("\n");
}

/* wypelnia tablice tab losowymi wartosciami */
void inicjuj()
{
	int ii;
	srand(times(NULL));
	for (ii=0;ii<N;ii++)
	{
		tab[ii] = rand()/20000;
	}	
}

int main(int argc, char *argv[])
{
	unsigned long tid1,tid2;
	Arg arg1  = {0,0,N/2-1};
	Arg arg2  = {N/2,0,N-1};
	Arg arg  = {0,N/2,N-1};
	inicjuj();
//pokaz(tab);
	if (pthread_create(&tid1,NULL,sort,&arg1))
		perror("blad pthread1");
	if (pthread_create(&tid2,NULL,sort,&arg2))
		perror("blad pthread1");
	//czekamy na koniec obu wtkw
	pthread_join(tid1,NULL);
	pthread_join(tid2,NULL);
//pokaz(tab);
	scal(&arg);
//pokaz(tab_wy);
	exit(0);
}

