/* przyklad sortowania na jednym wtku, brak te scalania */
/* przy kompilacji trzeba doda do gcc -lphtread */
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <sys/times.h>


typedef struct {
	int lewy;
	int srodkowy;
	int prawy;
} Arg; 
#define N 40000
int tab[N];
int tab_wy[N];

void *sort(void *argumenty)
{
	int ii,jj;
	int pom;
	Arg *arg = (Arg*)argumenty;
	printf("Bdziemy liczy L=%d S=%d P=%d\n",arg->lewy,arg->srodkowy,arg->prawy);
	for (ii=arg->lewy;ii<arg->prawy;ii++)
	{
		for (jj=ii+1; jj<=arg->prawy; jj++)
		{
			if (tab[jj]<tab[ii])
			{
				pom=tab[jj];
				tab[jj]=tab[ii];
				tab[ii]=pom;
			}
		}
	}
	printf("wtek %ld skonczyl\n",pthread_self());
	return NULL;
}

void inicjuj()
{
	int ii;
	srand(times(NULL));
	for (ii=0;ii<N;ii++)
	{
		tab[ii] = rand()/20000;
	}	
}

int main(int argc, char *argv[])
{
	unsigned long tid2;
	Arg arg2  = {0,0,N-1};
	inicjuj();
	if (pthread_create(&tid2,NULL,sort,&arg2))
		perror("blad pthread1");
	pthread_join(tid2,NULL);
	exit(0);
}

